package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrRuleTest;
import com.docus.server.infrastructure.dao.IOcrRuleTestDao;
import com.docus.server.infrastructure.mapper.OcrRuleTestMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 匹配策略表-调试 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrRuleTestDaoImpl extends BaseDaoImpl<OcrRuleTestMapper, OcrRuleTest> implements IOcrRuleTestDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrRuleTest findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrRuleTest 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrRuleTest ocrRuleTest) {
        return super.save(ocrRuleTest);
    }

    /**
     * 编辑
     *
     * @param ocrRuleTest 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrRuleTest ocrRuleTest) {
        return super.updateById(ocrRuleTest);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrRuleTest> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrRuleTest> query = Wrappers.lambdaQuery();

        Object assortId = searchDTO.getParams("assortId");
        query.eq(OcrRuleTest::getAssortId,assortId);

        query.orderByDesc(OcrRuleTest::getCreateTime);
        List<OcrRuleTest> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrRuleTest> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrRuleTest::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrRuleTest::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
